procedure chop (datafil : string;
                subdir  : string;
                datatype : integer);
var
  inputrec   : string;
  processno  : string;
  datahold   : holdfile;
  line       : integer;
  ofn        : string;
  Outputfile : data;
  goodinput  : boolean;
  datakind   : string;
  filedata   : data;
  firstrun,
  EndIn      : boolean;
  startno,
  endno,
  recno      : integer;
  tempstring : string;

begin
  line := 1;
  firstrun := true;
  startno := 1;
  endno := 300;
  recno := 0;
  EndIn := False;
  for I := 1 to maxrec do
    datahold[I] := '';
  assign(filedata, datafil);
  reset(filedata);
  while not(eof(filedata)) do
    begin
      readln(filedata, inputrec);
      if inputrec[1] <> '*' then
        begin
          datahold[line] := inputrec;
          line := line +1;
        end
      else
        begin
          processno := inputrec[4]+inputrec[5]+inputrec[6];
          if datatype <> 5 then
            begin
              str(datatype, datakind);
              if length(datakind)=1 then datakind := '0'+datakind;
              ofn := 'H'+processno+datakind;
            end
          else ofn := 'Chl'+processno;
          calibhead(datahold, datatype, firstrun, startno, endno, processno,
              line);
          val(processNo, recno, code);
          if not(EndIn) then
          if ((recno >= startno) and ((recno <= Endno) or (recno > 500))) then
            begin
              WriteAT(28,18, black, cyan, 'Processing File #'+ProcessNo);
              CheckFile (goodinput, subdir, ofn, Outputfile);
              if goodinput then
                begin
                  for i := 1 to (line-1) do
                    Writeln(Outputfile, datahold[i]);
                  Write(Outputfile, datahold[line]);
                  close(Outputfile);
                end;
              if (recno = (EndNo)) then EndIn := True;
            end;
          for I := 1 to maxrec do
            datahold[I] := '';
          line := 1;
        end;
      end; {while not eof...}
    close(filedata);
    RmWin;
  end;  {procedure}
