{****************************************************************************
 **                                                                        **
 **  This procedure draws an error window and message on the screen.       **
 **                                                                        **
 **  This procedure uses no other procedures or functions.                 **
 **                                                                        **
 **  Input : Errormessage string.                                          **
 **                                                                        **
 **  Output : Error window and message to the screen then pauses.          **
 **                                                                        **
 ****************************************************************************}

procedure Error (ErrorMsg :string);
begin
  MkWin(5,15,75,19,yellow,red,2);
  WriteBetween(5,75,17,white,red,ErrorMsg);
  WriteBetween(5,75,19,yellow,red,'< Any key to continue >');
Ch := ReadKey;
  RmWin;
end;
