Procedure Menu (var Cruisei : info);
var
  M, M2 : menu_record;
  Choice, Retcode : integer;
  Ch : char;

  Procedure Utilities;
  var
    M2 : menu_record;
    Choice2, RetCode : integer;
    Ch2 : char;
    Back : boolean;

    Procedure Define_M2;
      begin
        With M2 do
          begin
            Heading1   := 'CODES';
            Heading2   := 'Utilities Menu';
            Topic[1]   := '  Edit Header File';
            Topic[2]   := '  Process O2 Files';
            Topic[3]   := '  Process Nut Files';
            Topic[4]   := '  Process Chls Files';
            Topic[5]   := '  Process Prodo Files';
{            Topic[6]   := '  Edit Therm Arrangement';}
            Topic[6]   := '  Enter CUDLS Log Data';
            Topic[7]   := '  Main Menu';
            Topic[8]   := '  Quit';

            TotalPicks := 8;
            PicksPerLine := 1;
            AddPrefix := 3;
            TopleftXY[1] := 0;
            TopLeftXY[2] := 4;
            BoxType := 5;
            Margins := 5;
            Colors[1] := white;
            Colors[2] := red;
            Colors[3] := lightgray;
            Colors[4] := blue;
            Colors[5] := lightcyan;
            AllowEsc := true;
          end;
        end;

begin
  Back := False;
  repeat
  Offcursor;
  Fillscreen(1,1,80,25,white,blue,chr(177));
  ClearLine(25,white,black);
  WriteCenter(25,lightgray,black,'CODES/Net for Rosette');
  Choice2 := 1;
  Back := False;
  Define_M2;
  DisplayMenu(M2,False,Choice2,Retcode);
  writeln;
  GotoXY(1,20);
  If Retcode = 0 then
    begin
      case Choice2 of
        1: edhead(Cruisei);
        2: Chop(Cruisei.path+'O2\'+cruisei.Cruise+'O2','O2\',3);
        3: Chop(Cruisei.path+'Nut\'+cruisei.Cruise+'Nuts','Nut\', 4);
        4: Chop(Cruisei.path+'Chl\'+cruisei.cruise+'chla','Chl\',5);
        5: ChopPrdo(cruisei,holddata);
        6: TAS;
        7: Back := True;
        8: begin
             Clrscr;
          writecenter(9,white,red,'Program terminated normally...  Bye, Bye.');
             Delay(200);
             Halt;
           end;
      end;  {case}
    end;
  until Back;
end;

  Procedure Define_M;
  begin
    With M do
      begin
        Heading1   := 'CalCOFI Oceanographic';
        Heading2   := '  Data Entry System';
        Topic[1]   := '  Therms';
        Topic[2]   := '  Salts';
        Topic[3]   := '  O2s';
        Topic[4]   := '  Nuts ';
        Topic[5]   := '  Chls';
        Topic[6]   := '  Weather';
        Topic[7]   := '  Sta & Cast Description';
        Topic[8]   := '  Prodo';
        Topic[9]   := '  Utilities';
        Topic[10]  := '  Quit';
        TotalPicks := 10;
        PicksPerLine := 1;
        AddPrefix := 3;
        TopleftXY[1] := 0;
        TopLeftXY[2] := 4;
        BoxType := 5;
        Margins := 5;
        Colors[1] := white;
        Colors[2] := red;
        Colors[3] := lightgray;
        Colors[4] := blue;
        Colors[5] := lightcyan;
        AllowEsc := true;
      end;
  end;

begin
  Offcursor;
  query := ' ';
  Fillscreen(1,1,80,25,white,blue,chr(177));
  ClearLine(25,white,black);
  WriteCenter(25,lightgray,black,'CODES/Net for Rosette');
  Choice := 1;
  Define_M;
  DisplayMenu(M,False,Choice,Retcode);
  writeln;
  GotoXY(1,20);
  If Retcode = 0 then
    begin
      case Choice of
        1: Therms (cruisei, holddata);
        2: Salts (cruisei, holddata);
        3: O2 (cruisei, holddata);
        4: Nuts (cruisei, holddata);
        5: Chl (cruisei, holddata);
        6: Weather(cruisei, holddata);
        7: StaCast(cruisei, holddata);
        8: Prodo(cruisei, holddata);
        9: Utilities;
        10: begin
             ClrScr;
          writecenter(9,white,red,'Program terminated normally...  Bye, Bye.');
             Delay(200);
             Halt;
            end;
      end;  {case}
    end;
end;
