procedure SALTS  (var cruisei  : info;
                  var holddata : holdfile);

const
  maxrec = 40;
  salinometer  = '1';

var
  rec                    : string;
  saltfile               : data;
  Fn                     : string;
  procno,castno, therm   : string;
  samp1, samp2, hold1,
  hold2                  : string;
  Bottle,sample          : string;
  closeTS                : boolean;
  samp, pnumb            : integer;
  firstpno, pcnt2        : integer;
  cr1, cr2               : real;
  sampv1, sampv2         : string;
  outpath                : string;
  newfile                : boolean;

begin
  Outpath := cruisei.path+'salt\';
  Quitit := False;
  stop := false;
  newfile := true;
  closeTS := false;
  while newfile do
    begin
      ClrScr;
      FullCursor;
      Exiit := False;
      for i := 1 to maxrec do
        holddata[i] := '';
      newfile := false;
      CastNo  := '2';
      count := 4;
      samp := 0;
      Fillscreen(1,1,80,25,white,blue,chr(0));
      FBox(3,1,77,3,white,blue,177);
      FBox(1,4,80,25,yellow,blue,0);
      where(Outpath, pcnt2);
      str(pcnt2, hold1);
      Str(pcnt2,ProcNo);
      hold2 := hold1;
      while not(newfile) do
        begin
          str(samp, Sample);
          GoodInput := True;
          Exiit := False;
          IO_Setfields(7);
          IO_UserHook := @FKeys;
          IO_SetColors(14,0,4,7,14,4);
          IO_AllowEsc(True);
          IO_SoundBeeper(false);
          Therm := '';
          samp1 := '';
          samp2 := '';
          Bottle := '';
          IO_DefineStr(1, 7,2,7,2,      10,2,  ProcNo,  '###');
          IO_DefineStr(2, 1,3,1,3,      14,2,  CastNo,  '*');
          IO_DefineStr(3, 2,4,2,4,      17,2,  Sample,  '###');
          IO_DefineStr(4, 3,5,3,5,      21,2,  Therm,   '###');
          IO_DefineStr(5, 4,6,4,6,      25,2,  samp1,   '######');
          IO_DefineStr(6, 5,7,5,7,      32,2,  samp2,   '######');
          IO_DefineStr(7, 6,0,6,0,      39,2,  Bottle,  '*###');
          IO_DefineMsg(1,  10,1,   'Proc#');
          IO_DefineMsg(2,  14,1,   'Cast');
          IO_DefineMsg(3,  16,1,   'Sample#');
          IO_DefineMsg(4,  20,1,   'Temp');
          IO_DefineMsg(5,  25,1,   'CondRatio1');
          IO_DefineMsg(6,  32,1,   'CondRatio2');
          IO_DefineMsg(7,  39,1,   'Bottle');
          WriteCenter(25,yellow,blue,
'< F1 >-Help | <F2>-Edit |   [s,S,-]=SUB [w,W,*]=WORM   | < Esc >-Quit/Save');
          repeat
            query := ' ';
            exiit := false;
            goodinput := true;
            IO_Edit(Code);
            if code = 1 then
              exiit := true;
            if exiit then
              begin
                choices(query);
                whattodo(query, goodinput, closefile, newfile, exiit, quitit,
                  cruisei, closeTS);
              end; {case}
            sampv1 := strip('B', ' ',samp1);
            sampv2 := strip('B', ' ',samp2);
            val(sampv1[1]+sampv1[2], cr1, code);
            val(sampv2[1]+sampv2[2], cr2, code);
           if (abs(cr1-cr2) <> 0) and (query = ' ')then
              begin
                Beep;
                repeat
             ErrorWin ('Cond Ratios DO NOT Agree! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodinput := false;
               end;
             YN := ' ';
            val(sampv1[3]+sampv1[4]+sampv1[5], cr1, code);
            val(sampv2[3]+sampv2[4]+sampv2[5], cr2, code);
           if (abs(cr1-cr2) > 5) and (query = ' ') then
              begin
                Beep;
                repeat
             ErrorWin ('Cond Ratios DO NOT Agree! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodinput := false;
               end;
              YN := ' ';
           if (Bottle = '') and (query = ' ')then
              begin
                Beep;
                repeat
             ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodinput := false;
               end;
              YN := ' ';
              query := ' ';
              Fillscreen(1,1,80,1,white,blue,chr(177));
          until goodinput;  {continue edit}
          if not(newfile) AND not(closeTS) AND not(exiit) then
            begin
              if (Bottle[1] in ['s','S','-']) then Bottle := 'SUBS'
              ELSE if (Bottle[1] in ['w','W','*']) then Bottle := 'WORM';
              AddSpaces(ProcNo);
              Makelength(3, sample);
              Makelength(3, therm);
              Makelength(5, samp1);
              Makelength(5, samp2);
              Makelength(4, bottle);
              if ((bottle = 'WORM') or (bottle = 'SUBS')) then sample := '  0';
              if (bottle = 'WORM') then
                begin
                  hold2 := ProcNo;
                  ProcNo := '999';
                end;
              if (samp1[1] = '1') then
              rec := (ProcNo+' '+CastNo+' '+Sample+' '+Therm[1]+Therm[2]+'.'+Therm[3]+
              ' '+samp1[1]+'.'+samp1[2]+samp1[3]+samp1[4]+samp1[5]+samp1[6]+' '
              +samp2[1]+'.'+samp2[2]+samp2[3]+samp2[4]+samp2[5]+samp2[6]+' '+''''+Bottle+'''')
              else
                rec := (ProcNo+' '+CastNo+' '+Sample+' '+Therm[1]+Therm[2]+'.'+Therm[3]+
                  '  '+'.'+samp1+'  '+'.'+samp2+' '+''''+Bottle+'''');
              holddata[count-3]:= rec;
              count := count + 1;
              If ProcNo = '999' then
                begin
                  ProcNo := hold2;
                  sample := '  0';
                end;
              stripblanks(sample, code);
              val(sample, samp, code);
              samp := samp + 1;
              if count < 25 then  writeat(1,count,yellow,blue ,rec)
              else
                begin
                  ScrollUp(1,5,80,24);
                  writeAt(1,24,yellow, blue, rec);
                end;
              IO_resetfields;
              Fillscreen(1,1,80,1,white,blue,chr(177));
            end;  {if not(newfile) and Not(exiit)}
          if closeTS then
            begin
              val(holddata[4][1]+holddata[4][2]+holddata[4][3], firstpno,code);
              val (hold1, pnumb, code);
              if (firstpno <> pnumb) then
                begin
                  pnumb := firstpno;
                  str(pnumb, hold1);
                end;
              if pnumb < 200 then
                  begin
                    Stripblanks(hold1,code);
                    AddZeros(hold1);
                    Fn := ('H'+Hold1+'02');
                    CheckFile(goodinput, outpath, fn, saltfile);
                  end
              else
                begin
                  Stripblanks(ProcNo,code);
                  AddZeros(ProcNo);
                  Fn := ('H'+ProcNo+'02');
                  CheckFile(goodinput, outpath, fn, saltfile);
                end;
              repeat
                if not(goodinput) then
                  begin
                    writeat(3,2,yellow, red, 'Enter correct processing No: ');
                    gotoxy(33,2);
                    readln(pcnt2);
                    str(pcnt2, hold1);
                    str(pcnt2, procno);
                    AddZeros(ProcNo);
                    Fn := ('H'+ProcNo+'02');
                    ClearLine(2,yellow, blue);
                    CheckFile(goodinput, outpath, fn, saltfile);
                  end;
              until goodinput;
              str((count-6), sample);
              stripblanks(ProcNo,code);
              val(Procno, pcnt2, code);
              rec := (sample+'   '+hold1+'  '+Salinometer+'   '+ProcNo);
              writeln(Saltfile, rec);
              for i := 1 to (count-4) do
                Writeln(Saltfile, holddata[i]);
              close(saltfile);
              if pcnt2 < 100 then pcnt2 := pcnt2 + 1
              else pcnt2 := pnumb + 1;
              Savewhere(outpath, pcnt2);
              IO_resetfields;
              closeTS := false;
              if not(newfile) and not(quitit) then menu(cruisei);
              if quitit then
                begin
                  Halt;
                end;
            end;  {if closeTS}
        end;
    end;
end;
