Procedure Weather(var Cruisei  : info;
                  var holddata : holdfile);
const
  maxrec = 50;

var
  sta      : string;
  cst      : string;
  LineNo,Fn,
  dateline,
  year,
  StaNo    : string;
  Wavedir  : string;
  WaveHt   : string;
  WavePrd  : string;
  WindDir  : string;
  WindSpd  : string;
  Barom    : string;
  TDry     : string;
  TWet     : string;
  Weathr   : string;
  Cloudtyp : string;
  CloudAmt : string;
  Visib    : string;
  H2Ocolor : string;
  H2OTrans : string;
  allthings: string;
  YN       : char;
  outpath  : string;
  goodin,exiit,
  closefile,
  savedata,
  newpage  : boolean;
  weafile  : text;
  temp     : string;
  count    : integer;
  pcnt6    : integer;
  ship     : string;
  surftemp,
  remarks  : string;

begin
  outpath := cruisei.path+'weather\';
  Fn:=('weather');
  goodin := true;
  for i := 1 to maxrec do
    holddata[i] := '';
  appendfile(goodin, outpath, fn, weafile);
  where(outpath, pcnt6);
  Fillscreen(1,1,80,25,white,blue,chr(177));
  FBox(3,1,77,3,white,blue,177);
  count := 4;
  year := '';
  dateline := '';
  allthings := '';
  ship := cruisei.ship;
    if pcnt6 = 1 then
    begin
      dateline := date;
      i:= pos(',',dateline);
      for j := (i+1) to (i+5) do
        year := year + dateline[j];
      if cruisei.ship = 'JD' then
        temp := 'RV DAVID STARR JORDAN'
      else if (cruisei.ship = 'NM') or (cruisei.ship = 'NH') then
        temp := 'RV NEW HORIZON       ';
      allthings := ('CALCOFI '+cruisei.cruise+'             '+temp+'   '+Year);
      Writeln(weafile, allthings);
      allthings := '';
      temp := '';
    end;
  CloseFile := False;
  newpage := false;
  exiit := false;
  Sta := '';
  repeat
    Str(pcnt6, Sta);
    Cst := '2';
    LineNo := '';
    StaNo :=  '';
    Wavedir := '';
    WaveHt  := '';
    WavePrd := '';
    WindDir := '';
    WindSpd := '';
    Barom   := '';
    TDry    := '';
    TWet    := '';
    weathr  := '';
    CloudTyp:= '';
    CloudAmt:= '';
    Visib   := '';
    H2Ocolor:= '';
    H2OTrans:= '';
    SurfTemp := '';
    Remarks := 'ROSETTE';
    allthings := '';
    Exiit := False;
    GoodIn := True;
    SaveData := True;
    YN :=  ' ';
    IO_setfields(21);
    IO_UserHook := @FKeys;
    IO_SetColors(14,0,4,7,14,4);
    IO_AllowEsc(True);
    IO_SoundBeeper(false);
    IO_DefineStr(1, 17,2,17,2,     2,2,        Sta,  '###');
    IO_DefineStr(2, 1,3,1,3,       6,2,        Cst,  '##');
    IO_DefineStr(3, 2,4,2,4,       9,2,       Ship,  '**');
    IO_DefineStr(4, 3,5,3,5,      12,2,     LineNo,  '*****');
    IO_DefineStr(5, 4,6,4,6,      18,2,      StaNo,  '*****');
    IO_DefineStr(6, 5,7,5,7,      24,2,   WaveDir,  '##');
    IO_DefineStr(7, 6,8,6,8,      27,2,   WaveHt,  '##');
    IO_DefineStr(8, 7,9,7,9,      30,2,  WavePrd,  '##');
    IO_DefineStr(9, 8,10,8,10,    33,2,  WindDir,  '##');
    IO_DefineStr(10, 9,11,9,11,   36,2,  WindSpd,  '##');
    IO_DefineStr(11, 10,12,10,12, 39,2,    Barom,  '#####');
    IO_DefineStr(12, 11,13,11,13, 46,2,     TDry,  '###');
    IO_DefineStr(13, 12,14,12,14, 51,2,     TWet,  '###');
    IO_DefineStr(14, 13,15,13,15, 56,2,   Weathr,  '*');
    IO_DefineStr(15, 14,16,14,16, 58,2, CloudTyp,  '*');
    IO_DefineStr(16, 15,17,15,17, 60,2, CloudAmt,  '*');
    IO_DefineStr(17, 16,18,16,18, 62,2,    Visib,  '*');
    IO_DefineStr(18, 17,19,17,19, 64,2, H2OColor,  '##');
    IO_DefineStr(19, 18,20,18,20, 67,2, H2OTrans,  '##');
    IO_DefineStr(20, 19,21,19,21, 70,2, SurfTemp,  '###');
    IO_DefineStr(21, 20,0,20,0,   74,2,  Remarks,  '*******');
    IO_DefineMsg(1,  2,1,   'Proc#');
    IO_DefineMsg(2,  6,1,   'Cast#');
    IO_DefineMsg(3,  9,1,   'Ship');
    IO_DefineMsg(4,  12,1,  'Line#');
    IO_DefineMsg(5,  18,1,  'Sta#');
    IO_DefineMsg(6,  24,1,  'WaveDir');
    IO_DefineMsg(7,  27,1,  'WaveHt');
    IO_DefineMsg(8,  30,1,  'WavePeriod');
    IO_DefineMsg(9,  33,1,  'WindDir');
    IO_DefineMsg(10, 36,1,  'WindSpeed');
    IO_DefineMsg(11, 39,1,  'Barometer');
    IO_DefineMsg(12, 46,1,  'Air Temp Dry');
    IO_DefineMsg(13, 51,1,  'Air Temp Wet');
    IO_DefineMsg(14, 56,1,  'Weather');
    IO_DefineMsg(15, 58,1,  'Cloud Type');
    IO_DefineMsg(16, 60,1,  'Cloud Amount');
    IO_DefineMsg(17, 62,1,  'Visibility');
    IO_DefineMsg(18, 64,1,  'Water Color');
    IO_DefineMsg(19, 67,1,  'Water Transp');
    IO_DefineMsg(20, 70,1,  'Surf Temp');
    IO_DefineMsg(21, 74,1,  'Remarks');
    WriteCenter(25,yellow,blue,
'  < F1 > - Entry Help     |    <F2> - Line Editor    | < Esc > - Quit/Save');
    repeat
      FullCursor;
      query := ' ';
      exiit := false;
      goodin := true;
      TDry := '   ';
      TWet := '   ';
      Barom := '     ';
      SurfTemp := '    ';
      IO_Edit(Code);
      if (Remarks = '') and (query = ' ') then
              begin
                Beep;
                repeat
             ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodin := false;
               end;
              YN := ' ';
      if ((code = 1) and (goodin)) then
        begin
          repeat
            Errorwin('Do you want to quit? Y/N ', YN);
          until YN in ['n', 'N', 'y', 'Y','+','-'];
          if YN in ['y', 'Y','+'] then
            begin
              closefile := true;
              exiit := true;
            end
          else goodin := false;
        end;
      YN := ' ';
      FillScreen(1,1,80,1,white,blue,chr(177));
    until goodin;
    if not(Exiit) then
      begin
        makelength( 3, Sta);
        makelength( 2, Cst);
        makelength( 2, Ship);
        makelength( 2, WaveDir);
        makelength( 2, WaveHt);
        makelength( 2, WavePrd);
        makelength( 2, WindDir);
        makelength( 2, WindSpd);
        if Barom[1]='1' then barom := Barom[1]+Barom[2]+Barom[3]+
           Barom[4]+'.'+Barom[5]
        else Barom := '      ';
        if TDry[2] <> ' ' then TDry := TDry[1]+TDry[2]+'.'+TDry[3]
        else TDry := '    ';
        if TWet[2] <> ' ' then TWet := TWet[1]+TWEt[2]+'.'+TWet[3]
        else TWet := '    ';
        makelength( 1, Weathr);
        makelength( 1, CloudTyp);
        makelength( 1, CloudAmt);
        makelength( 1, Visib);
        makelength( 2, H2OColor);
        makelength( 2, H2OTrans);
        if SurfTemp[2] <> ' ' then SurfTemp := SurfTemp[1]+SurfTemp[2]+'.'+SurfTemp[3]
        else SurfTemp := '    ';
        If (Remarks[1] in ['p', 'P', '+']) then
          Remarks := 'PROD/RS';
        makelength( 7, Remarks);
        if length(LineNo) = 2 then LineNo := ' '+LineNo+'  ';
        if length(LineNo) = 3 then LineNo := ' '+LineNo[1]+LineNo[2]+'.'+LineNo[3];
        if length(LineNo) = 4 then LineNo := ' '+LineNo;
        if length(StaNo) = 2 then StaNo := ' '+StaNo+'  ';
        if length(StaNo) = 3 then StaNo := StaNo+'  ';
        if length(StaNo) = 4 then StaNo := ' '+StaNo;
allthings := (' '+Sta+' '+Cst+' '+Ship+' '+LineNo+' '+StaNo+' '+WaveDir+
' '+WaveHt+' '+WavePrd+' '+WindDir+' '+WindSpd+' '+Barom+' '+TDry+' '+TWet+
' '+Weathr+' '+CloudTyp+' '+CloudAmt+' '+Visib+' '+H2OColor+' '+H2OTrans+
' '+SurfTemp+Remarks);
        holddata[count-3] := allthings;
        if not(CloseFile) then IO_resetfields;
        count := count + 1;
        stripblanks(sta, pcnt6);
        pcnt6 := pcnt6 + 1;
        if count < 25 then writeat(1, count, yellow, blue, allthings)
        else
          begin
            ScrollUp(1,5,80,24);
            WriteAt(1,24,yellow, blue,allthings);
          end;
        allthings := '';
    end;  {if not(Exiit)...}
 until Closefile;
    repeat
      Errorwin('Do you want to save this data? Y/N ', YN);
    until YN in ['n', 'N', 'y', 'Y','+','-'];
    if YN in ['y', 'Y','+'] then
      begin
        savedata := true;
        YN := ' ';
      end
    else if YN in ['n','N','-'] then
      savedata := false;
    YN := ' ';
    if savedata then
      begin
        for i := 1 to (count-4) do
        Writeln(WeaFile, holddata[i]);
        SaveWhere(outpath, pcnt6);
      end;
    IO_resetfields;
    Close(WeaFile);
    offcursor;
end;