procedure Nuts (var cruisei  : info;
                var holddata : holdfile);
const
  maxrec = 40;

var
  rec                    : string;
  NutsFile               : data;
  Fn, flname             : string;
  procno, castno         : string;
  col1, col2, col3, col4,
  col5, col6, col7,
  sample, bottle         : string;
  col1msg, col2msg,
  col3msg, col4msg,
  col5msg,
  col6msg, col7msg       : string;
  closefile,goodinput,
  exiit,quitit,newpage   : boolean;
  samp,stdcnt, pcnt4     : integer;
  deci                   : boolean;
  temp                   : integer;
  outpath                : string;

begin
  OutPath := cruisei.path+'nut\';
  Quitit := False;
  stop := false;
  newpage := true;
  closefile := false;
  Fn := (cruisei.Cruise+'Nuts');
  AppendFile(goodinput, outpath, fn, NutsFile);
  where(OutPath, pcnt4);
  while newpage do
    begin
      ClrScr;
      FullCursor;
      Exiit := False;
      for i := 1 to maxrec do
        holddata[i] := '';
      stdcnt := 0;
      col1msg := 'NO3';
      col2msg := 'PO4';
      col3msg := 'Sil';
      col4msg := 'NO2';
      col5msg := 'Col5';
      col6msg := 'Col6';
      col7msg := 'Col7';
      newpage := false;
      CastNo  := '2';
      count := 4;
      samp := 1;
      rec := '';
      deci := true;
      str(pcnt4, ProcNo);
      Fillscreen(1,1,80,25,white,blue,chr(0));
      FBox(3,1,77,3,white,blue,177);
      fbox(1,4,80,25,yellow, blue,0);
      while not(newpage) do
        begin
          col1 := '';
          col2 := ',';
          col3 := ',,';
          col4 := ',,';
          col5 := '';
          col6 := '';
          col7 := '';
          str(samp, Sample);
          if ((count-3) in [3,4,5,6]) then
            begin
              col1 := 'STD';
              if ((count-3) = 3) then
                begin
                  stdcnt := 1;
                  col5 := '';
                end
              else col5 := ',,';
            end;
          if ((count-3) > 6) and (not(deci)) then
            begin
              Col1    := ProcNo;
              col1msg := 'Proc#';
              Col2    := CastNo;
              col2msg := 'Cast';
              if (count-3) = 7 then str((samp-6),Sample);
              Col3    := Sample;
              col3msg := 'Sample#';
              col4msg := 'NO3';
              col5msg := 'PO4';
              col6msg := 'Sil';
              col7msg := 'NO2';
            end
          else if ((deci) and ((stdcnt < 6) or (stdcnt > 8))) then
            begin
              col1msg := 'NO3';
              col2msg := 'PO4';
              col3msg := 'Sil';
              col4msg := 'NO2';
              col4 := '';
              col5msg := 'Col5';
              col6msg := 'Col6';
              col7msg := 'Col7';
            end
          else if ((deci) and ((stdcnt in [1,2,3,4,6,7,8])) or (col1 = 'STD')) then
            begin
                col1msg := 'STD';
                col1    := 'STD';
                col2msg := 'NO3';
                col2    := ',';
                col3msg := 'PO4';
                col3    := ',,';
                col4msg := 'Sil';
                col4    := ',,';
                col5msg := 'NO2';
                if (stdcnt <> 1) then col5 := ',,';
                col6msg := 'Col6';
                col7msg := 'Col7';
            end;
          GoodInput := True;
          Exiit     := False;
          IO_Setfields(7);
          IO_UserHook := @FKeys;
          IO_SetColors(14,0,4,7,14,4);
          IO_AllowEsc(True);
          IO_SoundBeeper(false);
          IO_DefineStr(1, 5,2,5,2, 10,2,  col1,  '****');
          IO_DefineStr(2, 1,3,1,3, 15,2,  col2,  '****');
          IO_DefineStr(3, 2,4,2,4, 20,2,  col3,  '****');
          IO_DefineStr(4, 3,5,3,5, 25,2,  col4,  '****');
          IO_DefineStr(5, 4,6,4,6, 30,2,  col5,  '****');
          IO_DefineStr(6, 5,7,5,7, 35,2,  col6,  '****');
          IO_DefineStr(7, 6,0,6,0, 40,2,  col7,  '****');
          IO_DefineMsg(1,  10,1,   Col1msg);
          IO_DefineMsg(2,  15,1,   Col2msg);
          IO_DefineMsg(3,  20,1,   Col3msg);
          IO_DefineMsg(4,  25,1,   Col4msg);
          IO_DefineMsg(5,  30,1,   Col5msg);
          IO_DefineMsg(6,  35,1,   Col6msg);
          IO_DefineMsg(7,  40,1,   Col7msg);
          WriteCenter(25,yellow,blue,
' No Decimals Required | <F2> - Editor | [-,s,S] = STD | < Esc > - Quit/Save ');
          if (samp >= 20) and (col1 <> 'STD') and not(deci) Then
              WriteCenter(4, yellow,black,
' Put a - in the first space of the Proc# field to switch back to STD entry.  ')
          else
            begin
              Clearline(4, yellow, blue);
              WriteCenter(4, yellow, blue, 'ProcNo = '+ProcNo);
            end;
          repeat
            query := ' ';
            exiit := false;
            goodinput := true;
            IO_Edit(Code);
            if code = 1 then
              exiit := true;
            if exiit then 
              begin
                choices(query);
                whattodo(query, goodinput, closefile, newpage, exiit, quitit,
                  cruisei, closeTS);
              end; {case}
            if (query = ' ') then
              begin
       if (not(deci) and (col7 = '') and not(col1[1] in ['-','s','S'])) then
                begin
                  Beep;
                  repeat
             ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                  until YN in ['n', 'N', 'y', 'Y','+','-'];
                    if YN in ['n','N','-'] then Goodinput := false;
                end;
               end;
              Fillscreen(1,1,80,1,white,blue,chr(177));
              query := ' ';
          until goodinput;  {continue edit}
          if not(newpage) AND not(closefile) AND not(exiit) then
            begin
              stripblanks(col4, code);
              stripblanks(col5, code);
              if Col1[1] in ['s','S','-'] then
                begin
                  Col1    := 'STD';
                  col1msg := 'STD';
                  col2msg := 'NO3';
                  col3msg := 'PO4';
                  col4msg := 'Sil';
                  col5msg := 'NO2';
                  col6msg := 'col6';
                  col7msg := 'col7';
                  if (Col2 <> ',') then Col2 := '.'+Col2;
                  if (Col3 <> ',') then
                    if (Col3 <> ',,') then Col3 := '.'+Col3
                    else if (Col2 = ',') and (Col3 = ',,') then
                      Col3 := ',';
                  if (Col4 <> ',') then
                    if (Col4 <> ',,') then
                      if (Col4 <> '0') then Col4 := '.'+Col4;
                  if (Col3 = ',,') and (Col4 = ',,') then
                      Col4 := ','
                  else if(Col3 = ',') and (Col4 = ',,') then
                        Col4 := ',';
                  if (Col5 <> ',') then
                    if (Col5 <> ',,') then
                      if (col5 <> '') then Col5 := '.'+Col5;
                  if (stdcnt = 1) or (stdcnt = 5) then col5 := ' ';
                  stdcnt := stdcnt + 1;
                  if (Col4 = ',,') and (Col5 = ',,') then
                      Col5 := ','
                  else if (Col4 = ',') and (Col5 = ',,') then
                      Col5 := ',';
                  if (count-3) > 7 then
                      deci := true
                  else deci := false;
                end
              else
                begin
                  if ((deci) and (Col1 <> 'STD') and (col1 <> ',,')) then
                     Col1 := '.'+Col1;
                  if ((deci) and (Col1 <> 'STD') and (col2 <> ',,')) then
                     Col2 := '.'+Col2;
                  if ((deci) and (Col1 <> 'STD') and (col3 <> ',,')) then
                     Col3 := '.'+Col3;
                  if ((deci) and (Col1 <> 'STD') and (col4 <> ',,')) then
                     if (col4 <> '0') then Col4 := '.'+Col4
                     else col4 := '0';
                end;
              if (Col1 <> 'STD') then MakeLength(4, Col1);
              Col2 := strip('B', ' ',col2);
              if (Col2 = '2') then CastNo := '2'
              else if Col2 = '1' then CastNo := '1';
              MakeLength(4, col2);
              MakeLength(4, col3);
              MakeLength(4, col4);
              MakeLength(4, col5);
              MakeLength(4, col6);
              MakeLength(4, col7);
           rec := (Col1+' '+Col2+' '+Col3+' '+Col4+' '+Col5+' '+Col6+' '+Col7);
              holddata[count-3] := rec;
              count := count + 1;
              if ((count-3) > 7) and (not(deci)) then
               begin
                 ProcNo := col1[2]+col1[3]+col1[4];
                 if (count-3) < 8 then sample := '1'
                 else sample := col3;
               end;
              stripblanks(sample, code);
              val(sample, samp, code);
              samp := samp + 1;
              stripblanks(ProcNo,code);
              val(Procno, pcnt4, code);
              if count < 25 then  writeat(1,count,yellow,blue ,rec)
              else
                begin
                  ScrollUp(1,5,80,24);
                  writeAt(1,24,yellow, blue, rec);
                end;
              rec := '';
              IO_resetfields;
              Fillscreen(1,1,80,1,white,blue,chr(177));
            end;  {if not(newfile) and Not(exiit)}
          if newpage or closefile then
            begin
              str((samp-1), sample);
              Writeln(NutsFile, 'F2');
              Writeln(NutsFile, 'N');
              Writeln(NutsFile, 'Std1');
              Writeln(NutsFile, 'Std2');
              for i := 1 to (count - 4) do
                Writeln(NutsFile, holddata[i]);
              AddZeros(procno);
              writeln(NutsFile, '***'+ProcNo);
              pcnt4 := pcnt4 + 1;
              if closefile then
                begin
                  close(NutsFile);
                  savewhere(outpath, pcnt4);
                  if not(quitit) then
                     begin
                       IO_resetfields;
                       Menu(cruisei);
                     end
                end;
              IO_resetfields;
              closefile := false;
              newpage := true;
              if quitit then
                begin
                  Halt;
                end;
            end;  {if closefile}
        end;
    end;
end;
