Procedure Prodo (var Cruisei  : info;
                   var holddata : holdfile);

var
  ProcNo, LAN : string;
  CT, StartT  : string;
  EndT, C14   : string;
  Time, Cast  : string;
  allthings: string;
  YN       : char;
  goodin,exiit,
  closefile,
  newpage,
  savedata : boolean;
  prodfile : text;
  temp     : string;
  count, 
  pcnt9    : integer;
  fn,
  outpath    : string;

begin

  OutPath := cruisei.path+'prodo\';
  Fn := (cruisei.cruise+'prod');
  goodin := true;
  for i := 1 to maxrec do
    holddata[i] := '';
  appendfile(goodin, outpath, fn, prodfile);
  where(outpath, pcnt9);
  Fillscreen(1,1,80,25,white,blue,chr(177));
  FBox(3,1,77,3,white,blue,177);
  count := 4;
  closefile := false;
  C14 := '103';
  repeat
    ProcNo := '';
    LAN := '';
    CT := '';
    StartT := '';
    EndT   := '';
    Cast := '2';
    FullCursor;
    allthings := '';
    Exiit := False;
    GoodIn := True;
    SaveData := True;
    query := ' ';
    YN :=  ' ';
    IO_setfields(7);
    IO_UserHook := @FKeys;
    IO_SetColors(14,0,4,7,14,4);
    IO_AllowEsc(True);
    IO_SoundBeeper(false);
    IO_DefineStr(1, 6,2,6,2,       3,2,   ProcNo,  '###');
    IO_DefineStr(2, 1,3,1,3,       7,2,     Cast,  '#');
    IO_DefineStr(3, 2,4,2,4,       9,2,      LAN,  '####');
    IO_DefineStr(4, 3,5,3,5,      14,2,       CT,  '####');
    IO_DefineStr(5, 4,6,4,6,      19,2,  StartT ,  '####');
    IO_DefineStr(6, 5,7,5,7,      24,2,     EndT,  '####');
    IO_DefineStr(7, 6,0,6,0,      29,2,      C14,  '###');
    IO_DefineMsg(1,  3,1,   'ProcNo');
    IO_DefineMsg(2,  7,1,   'Cast#');
    IO_DefineMsg(3,  9,1,   'LAN');
    IO_DefineMsg(4,  14,1,  'Civil Twilight');
    IO_DefineMsg(5,  19,1,  'Start Time');
    IO_DefineMsg(6,  24,1,  'End Time');
    IO_DefineMsg(7,  29,1,  'C14 (xxx)');
    WriteCenter(25,yellow,blue,
'  < F1 > - Entry Help     |    <F2> - Line Editor    |   < Esc > - Quit');
    repeat
      exiit := false;
      goodin := true;
      IO_Edit(Code);
      if (Code <> 1) and (C14[3] = '.') then
              begin
                Beep;
                repeat
     ErrorWin ('No decimals should be entered! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodin := false;
               end;
              YN := ' ';
      if ((code = 1) and (goodin)) then
        begin
          repeat
            Errorwin('Do you want to quit? Y/N ', query);
          until query in ['n', 'N', 'y', 'Y','+','-'];
          if query in ['y', 'Y','+'] then
            begin
              closefile := true;
              exiit := true;
              query := ' ';
            end
          else goodin := false;
        end;
    until goodin;
    if not(Exiit) then
      begin
        AddZeros(ProcNo);
        makelength( 5, LAN);
        makelength( 5, CT);
        makelength( 5, StartT);
        makelength( 5, EndT);
        YN := 'Y';
        if c14[1] <> '1' then
allthings :=
  (ProcNo+' '+Cast+LAN+CT+StartT+EndT+' '+C14[1]+'.'+C14[2]+C14[3])
        else if C14[1] = '1' then
allthings :=
  (ProcNo+' '+Cast+LAN+CT+StartT+EndT+' '+C14[1]+C14[2]+'.'+C14[3]);
        holddata[count-3] := allthings;
        IO_resetfields;
        count := count + 1;
        if count < 25 then writeat(1, count, yellow, blue, allthings)
        else
          begin
            ScrollUp(1,5,80,24);
            WriteAt(1,24,yellow, blue,allthings);
          end;
        allthings := '';
    end;  {if not(Exiit)...}
 until Closefile;
          repeat
            Errorwin('Do you want to save this data? Y/N ', query);
          until query in ['n', 'N', 'y', 'Y','+','-'];
          if query in ['y', 'Y','+'] then
            begin
              savedata := true;
              query := ' ';
            end
          else if query in ['n','N','-'] then
            savedata := false;
    if savedata then
      begin
        for i := 1 to (count-4) do
        Writeln(ProdFile, holddata[i]);
        savewhere(outpath, pcnt9);
      end;
    IO_resetfields;
    Close(ProdFile);
    offcursor;
end;
