Procedure StaCast (var Cruisei  : info;
                   var holddata : holdfile);

var
  sta, leg : string;
  cst      : string;
  CastType,
  DDMMYY,
  dateline,
  year,
  ship,
  lineone  : string;
  Time     : string;
  Lat, Lon : string;
  Depth    : string;
  Remarks  : string;
  allthings: string;
  YN       : char;
  outpath  : string;
  goodin,exiit,
  closefile,
  newpage,
  savedata : boolean;
  castfile : text;
  temp     : string;
  count    : integer;
  fn       : string;
  pcnt7,
  hold1    : integer;
  Station,
  Line     : string;

begin
  Outpath := cruisei.path+'stacst\';
  Fn:=('STACST');
  goodin := true;
  for i := 1 to maxrec do
    holddata[i] := '';
  appendfile(goodin, outpath, fn, castfile);
  where(outpath, pcnt7);
  Fillscreen(1,1,80,25,white,blue,chr(177));
  FBox(3,1,77,3,white,blue,177);
  count := 4;
  year := '';
  lineone := '';
  dateline := '';
  if pcnt7 = 1 then
    begin
      dateline := date;
      i:= pos(',',dateline);
      for j := (i+1) to (i+5) do
        year := year + dateline[j];
      if cruisei.ship = 'JD' then
        temp := 'RV DAVID STARR JORDAN '
      else if (cruisei.ship = 'NM') or (cruisei.ship = 'NH') then
        temp := 'RV NEW HORIZON        '
      else if (cruisei.ship = 'NM') or (cruisei.ship = 'NH') then
        temp := 'RV THOMAS THOMPSON    ';

      lineone := ('CALCOFI '+cruisei.cruise+'             '+Temp+'  '+Year);
      Writeln(Castfile, lineone);
      temp := '';
    end;
  closefile := false;
  Sta := '';
  DDMMYY := '';
  Line:= 'XX.0';
  Station := 'XX.0';
  temp := 'c';
  Leg := '01';
  repeat
    Line    := strip('B', ' ',Line);
    Station := strip('B', ' ',Station);
    FullCursor;
    if temp = 'c' then
      begin
        Cst := '01';
        CastType := 'CTD';
        Remarks := 'CTD DOWN CAST     ';
      end
    else if temp = 'r' then
      begin
        Cst := '02';
        CastType := 'ROS';
        Remarks := '   BOTTLE ROSETTE';
      end;
    Str(pcnt7,Sta);
    if allthings = '   02' then Leg := '02'
    else Leg := '01';
    Time := '';
    Depth := '';
    Lat := '       ';
    Lon := '        ';
    allthings := '';
    Exiit := False;
    GoodIn := True;
    SaveData := True;
    query := ' ';
    YN :=  ' ';
    IO_setfields(12);
    IO_UserHook := @FKeys;
    IO_SetColors(14,0,4,7,14,4);
    IO_AllowEsc(True);
    IO_SoundBeeper(false);
    IO_DefineStr(1, 10,2,10,2,     2,2,      Leg,  '##');
    IO_DefineStr(2, 1,3,1,3,       5,2,      Sta,  '###');
    IO_DefineStr(3, 2,4,2,4,       9,2,      Cst,  '##');
    IO_DefineStr(4, 3,5,3,5,      12,2,   DDMMYY,  '######');
    IO_DefineStr(5, 4,6,4,6,      19,2, CastType,  '***');
    IO_DefineStr(6, 5,7,5,7,      23,2,      Lat,  '#####');
    IO_DefineStr(7, 6,8,6,8,      29,2,      Lon,  '######');
    IO_DefineStr(8, 7,9,7,9,      36,2,     Time,  '####');
    IO_DefineStr(9, 8,10,8,10,    41,2,    Depth,  '#####');
    IO_DefineStr(10, 9,11,9,11,   47,2,  Remarks,  '******************');
    IO_DefineStr(11, 10,12,10,12, 66,2,     Line,  '####');
    IO_DefineStr(12, 11,0,11,0,   71,2,  Station,  '#####');
    IO_DefineMsg(1,  2,1,   'Leg');
    IO_DefineMsg(2,  5,1,   'Sta#');
    IO_DefineMsg(3,   9,1,  'Cast#');
    IO_DefineMsg(4,  12,1,  'DDMMYY');
    IO_DefineMsg(5,  19,1,  'CastType');
    IO_DefineMsg(6,  23,1,  'Lat (xxxxx)');
    IO_DefineMsg(7,  29,1,  'Lon (xxxxxx)');
    IO_DefineMsg(8,  36,1,  'HHMM (GMT)');
    IO_DefineMsg(9,  41,1,  'Depth');
    IO_DefineMsg(10, 47,1,  'Remarks');
    IO_DefineMsg(11, 66,1,  'Line(xx.x)');
    IO_DefineMsg(12, 72,1,  'Sta(xx.x)');
    WriteCenter(25,yellow,blue,
'  <F2> - Line Editor    |   < Esc > - Quit  ');
    repeat
      exiit := false;
      goodin := true;
      IO_Edit(Code);
      if (Code <> 1) and (Station[2] = 'X') then
              begin
                Beep;
                repeat
     ErrorWin ('Are you really finished (Sta X?)! Y to accept, N to edit.',YN);
                until YN in ['n', 'N', 'y', 'Y','+','-'];
                if YN in ['n','N','-'] then Goodin := false;
               end;
              YN := ' ';
      if ((code = 1) and (goodin)) then
        begin
          repeat
            Errorwin('Do you want to quit? Y/N ', query);
          until query in ['n', 'N', 'y', 'Y','+','-'];
          if query in ['y', 'Y','+'] then
            begin
              closefile := true;
              exiit := true;
              query := ' ';
            end
          else goodin := false;
        end;
    until goodin;
    if not(Exiit) then
      begin
        makelength( 5, Leg);
        makelength( 5, Sta);
        makelength( 5, Cst);
        makelength( 6, DDMMYY);
        If CastType = 'CTD' then temp := 'r'
        else temp := 'c';
        makelength( 5, CastType);
        if lat[1] <> ' ' then lat := lat[1]+lat[2]+lat[3]+lat[4]+'.'+lat[5]+'N'
        else lat := '       ';
        makelength( 7, Lat);
        if lon[1] <> ' ' then lon := lon[1]+lon[2]+lon[3]+lon[4]+lon[5]+'.'+
          lon[6]+'W'
        else lon := '        ';
        makelength( 8, Lon);
        makelength( 4, Time);
        makelength( 5, Depth);
        If Remarks[4] in ['p', 'P'] then
           Remarks := Remarks[1]+Remarks[2]+' BTLE PRODO-ROS';
        makelength( 18, Remarks);
        makelength( 5, Line);
        makelength( 6, Station);
        YN := 'Y';
allthings :=
  (Leg+Sta+Cst+DDMMYY+CastType+Lat+Lon+Time+Depth+Remarks+Line+Station);
        holddata[count-3] := allthings;
        {IO_resetfields;}
        count := count + 1;
        stripblanks(sta, hold1);
        if (hold1 < 300) and not(temp = 'r') then pcnt7 := hold1 + 1;
        if count < 25 then writeat(1, count, yellow, blue, allthings)
        else
          begin
            ScrollUp(1,5,80,24);
            WriteAt(1,24,yellow, blue,allthings);
          end;
        allthings := Leg;
        IO_resetfields;
    end;  {if not(Exiit)...}
  until Closefile;
          repeat
            Errorwin('Do you want to save this data? Y/N ', query);
          until query in ['n', 'N', 'y', 'Y','+','-'];
          if query in ['y', 'Y','+'] then
            begin
              savedata := true;
              query := ' ';
            end
          else if query in ['n','N','-'] then
            savedata := false;
    if savedata then
      begin
        for i := 1 to (count-4) do
        Writeln(CastFile, holddata[i]);
        val(Sta, pcnt7,code);
        savewhere(outpath, pcnt7);
      end;
    IO_resetfields;
    Close(CastFile);
    offcursor;
end;
