procedure Therms(var cruisei : info;
                var holddata : holdfile);
const
  Temp ='2';
var
  rec                             : string;
  thermfile                       : data;
  Fn                              : string;
  samp, thrmrack, GerNum          : integer;
  CastNo,ProcNo,Sample            : string;
  Upread,Thermrk, Ger             : string;
  lt1a, lt2a,mt1a,mt2a,ut1a, ut2a : string;
  lt1m, lt2m,mt1m,mt2m,ut1m, ut2m : string;
  a1, m1, a2, m2                  : integer;
  GoodInput,closeTS               : boolean;
  pcnt1                           : integer;
  outpath                         : string;
  depth                           : integer;
  newfile                         : boolean;
begin
  outpath := (cruisei.path+'therm\');
  Quitit := False;
  FullCursor;
  stop := false;
  newfile := true;
  closeTS := false;
  where(outpath, pcnt1);
  while newfile do
    begin
      ClrScr;
      for i := 1 to maxrec do
        holddata[i] := '';
      Exiit := False;
      newfile := false;
      CastNo  := '1';
      GerNum := 81;
      count := 4;
      depth := 5000;
      samp := 41;
      thrmrack := 1;
      Fillscreen(1,1,80,25,white,blue,chr(177));
      FBox(3,1,77,3,white,blue,177);
      Str(pcnt1,ProcNo);
      CstInfD(ProcNo, CastNo, YN, outpath);
      if not(YN in ['q', 'Q']) then
      begin
        YN := ' ';
      while not(newfile) do
        begin
          IO_setfields(20);
          IO_UserHook := @FKeys;
          IO_SetColors(14,0,4,7,14,4);
          IO_AllowEsc(True);
          IO_SoundBeeper(false);
          upRead   := '';
          str(samp, Sample);
          str(thrmrack, ThermRk);
          str(GerNum, Ger);
          lt1a := '    ';
          lt1m := '     ';
          lt2a := '    ';
          lt2m := '     ';
          mt1a := '    ';
          mt1m := '     ';
          mt2a := '    ';
          mt2m := '     ';
          ut1a := '   ';
          ut1m := '    ';
          ut2a := '   ';
          ut2m := '    ';
          GoodInput := True;
          Exiit := False;
          IO_DefineStr(1, 18,2,18,2,    1,2,   CastNo,  '*');
          IO_DefineStr(2, 1,3,1,3,      3,2,   ProcNo,  '###');
          IO_DefineStr(3, 2,4,2,4,      7,2,  Upread,  '####');
          IO_DefineStr(4, 3,5,3,5,      12,2,  Sample,  '##');
          IO_DefineStr(5, 4,6,4,6,      15,2,  Ger,     '##');
          IO_DefineStr(6, 5,7,5,7,      17,2,  ThermRk, '##');
          IO_DefineStr(7, 6,8,6,8,      20,2,  Lt1a,    '####');
          IO_DefineStr(8, 7,9,7,9,      25,2,  Lt1m,    '#####');
          IO_DefineStr(9, 8,10,8,10,    31,2,  Lt2a,    '####');
          IO_DefineStr(10, 9,11,9,11,   36,2,  Lt2m,    '#####');
          IO_DefineStr(11, 10,12,10,12, 42,2,  Mt1a,    '####');
          IO_DefineStr(12, 11,13,11,13, 47,2,  Mt1m,    '#####');
          IO_DefineStr(13, 12,14,12,14, 53,2,  Mt2a,    '####');
          IO_DefineStr(14, 13,15,13,15, 58,2,  Mt2m,    '#####');
          IO_DefineStr(15, 14,16,14,16, 64,2,  ut1a,    '###');
          IO_DefineStr(16, 15,17,15,17, 68,2,  ut1m,    '####');
          IO_DefineStr(17, 16,18,16,18, 73,2,  ut2a,    '###');
          IO_DefineStr(18, 17,0,17,0,   77,2,  ut2m,    '####');
          IO_DefineMsg(1,  1,1,   'Cast');
          IO_DefineMsg(2,  3,1,   'Samp#');
          IO_DefineMsg(3,  7,1,   'UpRead');
          IO_DefineMsg(4,  12,1, 'Niskin#');
          IO_DefineMsg(5,  15,1, 'Ger#');
          IO_DefineMsg(6,  17,1, 'Therm Rack');
          IO_DefineMsg(7,  20,1,  'Left t1');
          IO_DefineMsg(8,  25,1,  'Left T1');
          IO_DefineMsg(9,  31,1,  'Left t2');
          IO_DefineMsg(10, 36,1,  'Left T2');
          IO_DefineMsg(11, 42,1,  'Mid t1');
          IO_DefineMsg(12, 47,1,  'Mid T1');
          IO_DefineMsg(13, 53,1,  'Mid t2');
          IO_DefineMsg(14, 58,1, 'Mid T2');
          IO_DefineMsg(15, 64,1, 'Unp t1');
          IO_DefineMsg(16, 68,1, 'Unp T1');
          IO_DefineMsg(17, 73,1, 'Unp t2');
          IO_DefineMsg(18, 75,1, 'Unp T2');
          WriteCenter(25,yellow,blue,
'  <F2> - Line Editor    | < Esc > - Quit/Save  ');
          repeat
            query :=  ' ';
            exiit := false;
            goodinput := true;
            IO_Edit(Code);
            if code = 1 then
              exiit := true;
            if exiit then
              begin
                choices(query);
                whattodo(query, goodinput, closefile, newfile, exiit,
                  quitit, cruisei, closeTS);
              end; {case}
            if not(exiit) and goodinput then
              begin
                val(upread, a1, code);
                if (a1 > depth) then
                begin
                  Beep;
                  repeat
                    ErrorWin (
              'Depth is getting deeper instead of shallower?  OK?',YN);
                  until YN in ['n', 'N', 'y', 'Y','-','+'];
                  if YN in ['n','N','-'] then Goodinput := false;
                end
                else depth := a1;
                YN := ' ';
                if sample <> '' then
                  stripblanks(sample, samp);
                if upread <> '' then
                  stripblanks(upread,a1);
                if Ger <> '' then
                  stripblanks(Ger,a1);
                if Thermrk <> '' then
                  stripblanks(Thermrk,a1);
                if lt1a <> '   ' then
                  begin
                    stripblanks(lt1a, a1);
                    if lt1m <> '    ' then
                      stripblanks(lt1m, m1);
                    if lt2a <> '   ' then
                      stripblanks(lt2a, a2);
                    if lt2m <> '    ' then
                      stripblanks(lt2m, m2);
                    if lt1a <> '   ' then
                    if (abs(m1-m2)>20) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(20,1,white, blue, '|------ Left -------|');
                        repeat
             ErrorWin ('Left Mains DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then Goodinput := false;
                      end
                    else if (abs(a1-a2)>90) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(20,1,white, blue, '|------ Left -------|');
                        repeat
             ErrorWin ('Left Auxs DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then Goodinput := false;
                      end;
                    YN := ' ';
                  end;
                if mt1a <> '   ' then
                  begin
                    stripblanks(mt1a, a1);
                    if mt1m <> '    ' then
                      stripblanks(mt1m, m1);
                    if mt2a <> '   ' then
                      stripblanks(mt2a, a2);
                    if mt2m <> '    ' then
                     stripblanks(mt2m, m2);
                    if (abs(m1-m2)>20) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(42,1,white, blue, '|------- Mid -------|');
                                  repeat
              ErrorWin ('Mid Mains DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then goodinput := false;
                      end
                    else if (abs(a1-a2)>90) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(42,1,white, blue, '|------- Mid -------|');
                        repeat
              ErrorWin ('Mid Auxs DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then Goodinput := false;
                      end;
                    YN := ' ';
                  end;
                if ut1a <> '   ' then
                  begin
                    stripblanks(ut1a, a1);
                    if ut1m <> '    ' then
                      stripblanks(ut1m, m1);
                    if ut2a <> '   ' then
                      stripblanks(ut2a, a2);
                    if ut2m <> '    ' then
                      stripblanks(ut2m, m2);
                    if (abs(m1-m2)>2) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(64,1,white, blue, '|----- Unp -----|');
                        repeat
                    ErrorWin (
                'Unprotected Therms DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then goodinput := false;
                      end
                    else if (abs(a1-a2)>9) and (query = ' ') then
                      begin
                        Beep;
                        WriteAT(64,1,white, blue, '|----- Unp -----|');
                        repeat
              ErrorWin (
              ' Unprotected Auxs DO NOT Agree! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then Goodinput := false;
                      end;
                      YN := ' ';
                    end;
              end;{if not(exiit)}
              if (samp > 87) and (ut2m = '    ') and (query = ' ') then
                      begin
                        Beep;
                        repeat
             ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                        until YN in ['n', 'N', 'y', 'Y','-','+'];
                        if YN in ['n','N','-'] then Goodinput := false;
                      end;
              YN := ' ';
              query := ' ';
              Fillscreen(1,1,80,1,white,blue,chr(177));
      until goodinput;
      if not(newfile) AND not(exiit) AND not(closeTS) then
        begin
          Makelength(3, sample);
          Makelength(4, Upread);
          MakeLength(2, Ger);
          MakeLength(2, ThermRk);
          Add_End0(lt1a, 4);
          Add_End0(lt1m, 5);
          Add_End0(lt2a, 4);
          Add_End0(lt2m, 5);
          Add_End0(mt1a, 4);
          Add_End0(mt1m, 5);
          Add_End0(mt2a, 4);
          Add_End0(mt2m, 5);
          Add_End0(ut1a, 3);
          Add_End0(ut1m, 4);
          Add_End0(ut2a, 3);
          Add_End0(ut2m, 4);
      rec := (' '+CastNo+' '+Sample+' '+UpRead+' '+Temp+' '+Ger+ThermRk+' '+
        lt1a+' '+lt1m+' '+lt2a+' '+lt2m+' '+mt1a+' '+mt1m+' '+mt2a+ ' '+
        mt2m+' '+ut1a+' '+ut1m+' '+ut2a+' '+ut2m);
        holddata[count-3] := rec;
        count := count + 1;  {screen write position}
        stripblanks(sample, samp);
        samp := samp + 1;    {sample increment}
        stripblanks(Ger, GerNum);
        GerNum := GerNum + 1; {GerBtl# increment}
        stripblanks(ThermRk, thrmrack);
        thrmrack := thrmrack + 1; {therm rack increment}
        stripblanks(procno, code);
        val(procno, pcnt1, code);
        if (count < 25) then
          writeat(1,count,yellow,blue ,rec)
        else
          begin
            ScrollUp(1,5,80,24);
            writeAt(1,24,yellow, blue, rec);
          end;
        IO_ResetFields;
        FillScreen(1,1,80,1,white,blue,chr(177));
      end;  {if not(newfile) AND not(exiit)...}
      if closeTS then
        begin
          AddZeros(ProcNo);
          Fn := ('H'+ProcNo+'01');
          CheckFile(goodinput, outpath, fn, thermfile);
          repeat
            if not(goodinput) then
              begin
                writeat(3,2,yellow, red, 'Enter correct processing No: ');
                gotoxy(33,2);
                readln(pcnt1);
                str(pcnt1, procno);
                AddZeros(ProcNo);
                Fn := ('Therm\'+'H'+ProcNo+'01');
                ClearLine(2,yellow, blue);
                CheckFile(goodinput, cruisei.path, fn, thermfile);
              end;
          until goodinput;
          for i := 1 to (count-4) do
            Writeln(Thermfile, holddata[i]);
          close(thermfile);
          if pcnt1 < 200 then pcnt1 := pcnt1 +1;
          savewhere(outpath, pcnt1);
          IO_ResetFields;
          closeTS := false;
          if not(newfile) and not(quitit) then WMenu(cruisei);
          if quitit then
            begin
              Halt;
            end;
        end; {if closeTS}
    end; {while not exiit}
    end; {while not Q...}
  end; {while not quitit}
end;
